// Copyright 2015 Vaqtincha

/** SelfGrenades
*
*	Last update:
*	  06/11/2015
*
*	Description:
*	Grenades do not cause damage to the one who dumped her
*
*	Credits:
*	- Avalanche for plugin "Flashbang Dynamic Light"
*	- Simon Logic for plugin "HE SelfDamage Free"
*	- VEN
*
*	Games supported:
*	- Counter-Strike
*	- Condition Zero(not tested!)
*
*	Modules required:
*	- Hamsandwich
*	
*	Cvars:
*	selfgrenades <(Default: 3)>
*	0 - Disable
*	1 - Selfflash (FB grenade)
*	2 - Selfdamage (HE grenade)
*	3 - 1 & 2 options together
*
***************************************************************/

#include <amxmodx>
#include <hamsandwich>

#define SELFFB	(1<<0)
#define SELFHE	(1<<1)

new gmsgScreenFade, selfmode
const DMG_HEGRENADE = (1<<24)

public plugin_init()
{
	register_plugin("SelfGrenades","0.0.1","Vaqtincha")
	RegisterHam(Ham_TakeDamage, "player", "onPlayerDamage")
	
	selfmode = register_cvar("selfgrenades", "3")
	
	// from VEN
	register_event("ScreenFade","event_flash","be","1>0","2>0","3=0","4=255","5=255","6=255","7>199")
	gmsgScreenFade = get_user_msgid("ScreenFade")
}

public event_flash(id)
{
	if(get_pcvar_num(selfmode) & SELFFB)
	{
		message_begin(MSG_ONE,gmsgScreenFade,_,id)
		write_short(0)
		write_short(0)
		write_short(1<<2)
		write_byte(0)
		write_byte(0)
		write_byte(0)
		write_byte(0)
		message_end()
	}
}

public onPlayerDamage(victim, inflictor, attacker, Float:dmg, dmg_type)
{
	if(get_pcvar_num(selfmode) & SELFHE)
	{
		if(dmg_type & DMG_HEGRENADE && victim == attacker)
			return HAM_SUPERCEDE
	}
	return HAM_IGNORED
}